/*
 * This file is generated by jOOQ.
 */
package nu.studer.sample.tables;


import java.sql.Date;
import java.util.Arrays;
import java.util.List;

import javax.annotation.processing.Generated;

import nu.studer.sample.Keys;
import nu.studer.sample.Selfbooster;
import nu.studer.sample.tables.records.PurposeRecord;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row8;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * Таблица целей
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.15.1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Purpose extends TableImpl<PurposeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>selfbooster.purpose</code>
     */
    public static final Purpose PURPOSE = new Purpose();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<PurposeRecord> getRecordType() {
        return PurposeRecord.class;
    }

    /**
     * The column <code>selfbooster.purpose.uuid</code>.
     */
    public final TableField<PurposeRecord, java.util.UUID> UUID = createField(DSL.name("uuid"), SQLDataType.UUID.nullable(false).defaultValue(DSL.field("uuid_generate_v4()", SQLDataType.UUID)), this, "");

    /**
     * The column <code>selfbooster.purpose.description</code>.
     */
    public final TableField<PurposeRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>selfbooster.purpose.created_at</code>.
     */
    public final TableField<PurposeRecord, Date> CREATED_AT = createField(DSL.name("created_at"), SQLDataType.DATE.defaultValue(DSL.field("CURRENT_DATE", SQLDataType.DATE)), this, "");

    /**
     * The column <code>selfbooster.purpose.desired_at</code>.
     */
    public final TableField<PurposeRecord, Date> DESIRED_AT = createField(DSL.name("desired_at"), SQLDataType.DATE, this, "");

    /**
     * The column <code>selfbooster.purpose.due_at</code>.
     */
    public final TableField<PurposeRecord, Date> DUE_AT = createField(DSL.name("due_at"), SQLDataType.DATE, this, "");

    /**
     * The column <code>selfbooster.purpose.percent_completion</code>. процент
     * выполнения
     */
    public final TableField<PurposeRecord, Double> PERCENT_COMPLETION = createField(DSL.name("percent_completion"), SQLDataType.DOUBLE, this, "процент выполнения");

    /**
     * The column <code>selfbooster.purpose.customer_uuid</code>.
     */
    public final TableField<PurposeRecord, java.util.UUID> CUSTOMER_UUID = createField(DSL.name("customer_uuid"), SQLDataType.UUID, this, "");

    /**
     * The column <code>selfbooster.purpose.category_uuid</code>.
     */
    public final TableField<PurposeRecord, java.util.UUID> CATEGORY_UUID = createField(DSL.name("category_uuid"), SQLDataType.UUID, this, "");

    private Purpose(Name alias, Table<PurposeRecord> aliased) {
        this(alias, aliased, null);
    }

    private Purpose(Name alias, Table<PurposeRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment("Таблица целей"), TableOptions.table());
    }

    /**
     * Create an aliased <code>selfbooster.purpose</code> table reference
     */
    public Purpose(String alias) {
        this(DSL.name(alias), PURPOSE);
    }

    /**
     * Create an aliased <code>selfbooster.purpose</code> table reference
     */
    public Purpose(Name alias) {
        this(alias, PURPOSE);
    }

    /**
     * Create a <code>selfbooster.purpose</code> table reference
     */
    public Purpose() {
        this(DSL.name("purpose"), null);
    }

    public <O extends Record> Purpose(Table<O> child, ForeignKey<O, PurposeRecord> key) {
        super(child, key, PURPOSE);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Selfbooster.SELFBOOSTER;
    }

    @Override
    public UniqueKey<PurposeRecord> getPrimaryKey() {
        return Keys.PK_PURPOSE_ID;
    }

    @Override
    public List<UniqueKey<PurposeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UNQ_PURPOSE_USERID);
    }

    @Override
    public List<ForeignKey<PurposeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.PURPOSE__FK_PURPOSE_CUSTOMER, Keys.PURPOSE__FK_PURPOSE_PURPOSE_CATEGORIES);
    }

    private transient Customer _customer;
    private transient PurposeCategories _purposeCategories;

    public Customer customer() {
        if (_customer == null)
            _customer = new Customer(this, Keys.PURPOSE__FK_PURPOSE_CUSTOMER);

        return _customer;
    }

    public PurposeCategories purposeCategories() {
        if (_purposeCategories == null)
            _purposeCategories = new PurposeCategories(this, Keys.PURPOSE__FK_PURPOSE_PURPOSE_CATEGORIES);

        return _purposeCategories;
    }

    @Override
    public Purpose as(String alias) {
        return new Purpose(DSL.name(alias), this);
    }

    @Override
    public Purpose as(Name alias) {
        return new Purpose(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Purpose rename(String name) {
        return new Purpose(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Purpose rename(Name name) {
        return new Purpose(name, null);
    }

    // -------------------------------------------------------------------------
    // Row8 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row8<java.util.UUID, String, Date, Date, Date, Double, java.util.UUID, java.util.UUID> fieldsRow() {
        return (Row8) super.fieldsRow();
    }
}
